﻿// Mixer.cs (c) Charles Petzold, 2009
using System.Collections.Generic;

namespace Petzold.SoundSynthesis
{
    public class Mixer : ISampleProvider
    {
        public IList<ISampleProvider> Inputs { get; protected set; }

        public Mixer()
        {
            Inputs = new List<ISampleProvider>();
        }

        public short GetNextSample()
        {
            int sample = 0;

            if (Inputs.Count > 0)
            {
                int multiplier = 65536 / Inputs.Count;

                foreach (ISampleProvider input in Inputs)
                    sample += multiplier * input.GetNextSample();
            }

            return (short)(sample >> 16);
        }
    }
}
